#! /bin/bash


enter=`echo -ne " \n "`
saida="programasMonitorados.out"
arquivodeSaida="fonte.stp"

ascii() {
  [ "$1" -lt 256 ] || return 1
  printf "\\$(printf '%03o' "$1")"
}

cont=`grep '\[' $1 | cut -f2 -d '[' | cut -f1 -d ']' | wc -l`
grep '\[' $1 | cut -f2 -d '[' | cut -f1 -d ']' > programasMonitorados.out

#cat TMP.out

globalVariable="global pids,pathnameRoot,argReplaced,nomePrograma\n\n"

funcaoSendData="
function sendData(pid: long, syscallN: long, argstr: string, nomePrograma: string)\n%{\n
	\n
	\t uint16_t pid;\n
	\t uint8_t sys;\n
	\t uint8_t size;\n
	\t uint8_t sizePrograma;\n
	\n
	\t if(STAP_ARG_syscallN > 255)\n
		\t \t return;\n
\n
	\t pid = STAP_ARG_pid;\n
	\t sys = STAP_ARG_syscallN-1;\n
 \n
	\t STAP_PRINTF(\"%c%c%c\", *((char *)&pid), *(( (char *)&pid)+1),*((char *)&sys));\n
	
	\t if(1) // TODO \n
	\t {\n
		\t \t char argstr[256];\n
		\t \t char nomePrograma[128];\n
\n
		\t \t size = strlen(STAP_ARG_argstr);\n
		\t \t strncpy(argstr,STAP_ARG_argstr,size);\n
\n		
		\t \t sizePrograma = strlen(STAP_ARG_nomePrograma);\n
		\t \t strncpy(nomePrograma,STAP_ARG_nomePrograma,sizePrograma);\n
		\n
		\t \t argstr[size]=0;\n
		\t \t nomePrograma[sizePrograma]=0;\n
\n
		\t \t STAP_PRINTF(\"%c%s%c%s\", *((char *)&size), argstr,*((char *)&sizePrograma), nomePrograma);\n
	\t }\n
%}\n
"

funcaoPathRoot="
function pathRoot:string()\n{
\n\t	tc = task_current()
\n\t	pwd_dentry = @cast(tc, \"task_struct\")->fs->pwd->dentry
\n\t	pwd_mnt = @cast(tc, \"task_struct\")->fs->pwd->mnt
\n\t	pwd_path = task_dentry_path(tc, pwd_dentry, pwd_mnt)
\n
\n\t	return pwd_path
\n}\n
"

probeSyscall="
probe syscall.*\n{

\n\t	pidN = pid()
\n\t	if( pids[pidN] > 0 )
\n\t\t	{
\n\t\t		argReplaced = str_replace(argstr,\"\\\".\\\"\",pathnameRoot);
\n\t\t		//argReplaced = pathnameRoot.\",\".argstr
\n\t\t		sendData(pidN,pids[pidN],argReplaced,nomePrograma)
\n\t	}
\n}\n
"
echo -ne $globalVariable >> $arquivodeSaida
echo -ne $funcaoSendData >> $arquivodeSaida
echo -ne $funcaoPathRoot >> $arquivodeSaida
echo -ne $probeSyscall   >> $arquivodeSaida

for (( i = 1; i <= $cont; i++ )); do
	num=$"$i"p
	command=$"sed -n $num $saida"
	fun=`$command`
	
	script=$"\nprobe process(\"$fun\").syscall\n{
	\n\t pathnameRoot = pathRoot()
	\n\t nomePrograma = \"$fun\"
	\n\t var = \$syscall
	\n\t pids[pid()]= var + 1 \n}\n"

	echo -ne $script >> $arquivodeSaida
done

